Debian Bug report logs - #651993
dpkg-mergechangelogs fails if any changelog contains an invalid version

version graph

Package: dpkg-dev; Maintainer for dpkg-dev is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg-dev is src:dpkg.

Reported by: Martin Packman <martin.packman@canonical.com>

Date: Tue, 13 Dec 2011 21:39:01 UTC

Severity: normal

Found in version dpkg/1.16.2~really1.16.1.2

Fixed in version dpkg/1.16.2~wipmultiarch

Done: Guillem Jover <guillem@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#651993; Package dpkg. (Tue, 13 Dec 2011 21:39:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Martin Packman <martin.packman@canonical.com>:
New Bug report received and forwarded. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 13 Dec 2011 21:39:05 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Martin Packman <martin.packman@canonical.com>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: dpkg-mergechangelogs fails if any changelog contains an invalid version
Date: Tue, 13 Dec 2011 21:36:07 +0000
Package: dpkg
Version: 1.16.1.2
Severity: normal


As reported downstream in launchpad, dpkg-mergechangelogs fails trying to merge
the gcc debian changelog:

    <https://bugs.launchpad.net/bzr-builddeb/+bug/893495>

Reproduce with the attatchments on that bug, and:

    $ dpkg-mergechangelogs changelog.BASE changelog.OTHER changelog.THIS

This is caused by this block appearing, which as an invalid version:

    egcs (ss-970814-1) experimental; urgency=low

      * Initial packaging (of initial snapshot!)

     -- Galen Hazelwood <galenh@micron.net>  Wed, 20 Aug 1997 00:36:28 +0000

This particular issue was introduced in dpkg 1.16.0.1  - specifically the changeset:

    0cacb0c3a1d1f837c957f3917a040ace6d60f9e7
    Dpkg::Version: update version_check to forbid versions starting with non digits

So, the change was deliberate, but the effect on dpkg-mergechangelogs seems
unintended.

Note that this bug is not present on my system with dpkg 1.15.8.12 so in some senses
it's a regression, though invalid versions were not explicitly handled then either.


-- System Information:
Debian Release: 6.0.3
  APT prefers stable-updates
  APT policy: (500, 'stable-updates'), (500, 'proposed-updates'), (500, 'stable')
Architecture: i386 (i686)

Kernel: Linux 2.6.32-5-686 (SMP w/1 CPU core)
Locale: LANG=en_GB.UTF-8, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages dpkg depends on:
ii  coreutils               8.5-1            GNU core utilities
ii  libbz2-1.0              1.0.5-6          high-quality block-sorting file co
ii  libc6                   2.11.2-10        Embedded GNU C Library: Shared lib
ii  libselinux1             2.0.96-1         SELinux runtime shared libraries
ii  xz-utils                5.0.0-2          XZ-format compression utilities
ii  zlib1g                  1:1.2.3.4.dfsg-3 compression library - runtime

dpkg recommends no packages.

Versions of packages dpkg suggests:
ii  apt                    0.8.10.3+squeeze1 Advanced front-end for dpkg

-- no debconf information




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#651993; Package dpkg. (Tue, 13 Dec 2011 22:09:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Martin Packman <martin.packman@canonical.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Tue, 13 Dec 2011 22:09:05 GMT) Full text and rfc822 format available.

Message #10 received at 651993@bugs.debian.org (full text, mbox):

From: Martin Packman <martin.packman@canonical.com>
To: 651993@bugs.debian.org
Subject: Bug#651993: dpkg-mergechangelogs fails if any changelog contains an invalid version
Date: Tue, 13 Dec 2011 22:07:44 +0000
[Message part 1 (text/plain, inline)]
See attached patch making the dpkg-mergechangelogs only tolerate bad
versions, leaving the existing strict handling in Dpkg::Version.

I'm a little rusty on perl, but happy to change or update things as
requested. I assume the change in general is acceptable as it looks
like the code currently tries to do something like this but doesn't
quite get it right.

Notes on the patch:

* Moves construction of Dpkg::Version objects upwards into the main
merge loop rather than inside the compare. This prevents over-warning
about the same invalid versions and actually gets a (just barely)
measurable speedup.

* I'm unconvinced by the current compare logic when one version is
undefined, but have left it as it was preexisting (but inactive).
Always returning 0 seems more suitable as that then does no
reordering.

* The added test is very simplistic currently, if there are particular
things we worry about with how the merge should be handled it could be
elaborated. Should I example.com out the data? It's just copied from
the original bug report currently.
[mergechangelogs_tolerate_bad_versions.patch (application/octet-stream, attachment)]

Bug reassigned from package 'dpkg' to 'dpkg-dev'. Request was from Raphaël Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Fri, 16 Dec 2011 16:21:04 GMT) Full text and rfc822 format available.

Bug No longer marked as found in versions dpkg/1.16.1.2. Request was from Raphaël Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Fri, 16 Dec 2011 16:21:05 GMT) Full text and rfc822 format available.

Added tag(s) pending. Request was from Raphaël Hertzog <hertzog@debian.org> to control@bugs.debian.org. (Wed, 21 Dec 2011 09:54:14 GMT) Full text and rfc822 format available.

Message sent on to Martin Packman <martin.packman@canonical.com>:
Bug#651993. (Wed, 21 Dec 2011 09:54:20 GMT) Full text and rfc822 format available.

Message #19 received at 651993-submitter@bugs.debian.org (full text, mbox):

From: Raphaël Hertzog <hertzog@debian.org>
To: 651993-submitter@bugs.debian.org
Subject: Bug#651993 marked as pending
Date: Wed, 21 Dec 2011 09:51:19 +0000
tag 651993 pending
thanks

Hello,

Bug #651993 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=dpkg/dpkg.git;a=commitdiff;h=834f83e

---
commit 834f83e490eb1c2907adf67a2b43a04ccd900b9e
Author: Raphaël Hertzog <hertzog@debian.org>
Date:   Wed Dec 21 10:02:36 2011 +0100

    dpkg-mergechangelogs: do not error out on invalid versions
    
    The usage of version_compare() has the side effect of erroring out as
    soon as you encounter an invalid version. Replacing this call
    with a comparison operator invoked on Dpkg::Version objects fixes
    the issue.
    
    Closes: #651993
    Reported-by: Martin Packman <martin.packman@canonical.com>

diff --git a/debian/changelog b/debian/changelog
index 9410c49..3866df3 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -62,6 +62,8 @@ dpkg (1.16.2) UNRELEASED; urgency=low
     it assumes all build dependencies must be satisfied on the listed
     architecture. Closes: #648180 Thanks to Colin Watson for the patch.
   * Error out if a dpkg database .list file is not a regular file. LP: #369898
+  * Fix dpkg-mergechangelogs to not error out on invalid versions.
+    Closes: #651993
 
   [ Jonathan Nieder ]
   * Bump po4a version in Build-Depends to 0.41, since earlier versions do




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#651993; Package dpkg-dev. (Wed, 21 Dec 2011 09:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 21 Dec 2011 09:57:07 GMT) Full text and rfc822 format available.

Message #24 received at 651993@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Martin Packman <martin.packman@canonical.com>, 651993@bugs.debian.org
Subject: Re: Bug#651993: dpkg-mergechangelogs fails if any changelog contains an invalid version
Date: Wed, 21 Dec 2011 10:55:20 +0100
Hi,

On Tue, 13 Dec 2011, Martin Packman wrote:
> See attached patch making the dpkg-mergechangelogs only tolerate bad
> versions, leaving the existing strict handling in Dpkg::Version.

Thanks for the report and the patch. I pushed a fix in git master.
The fix itself is really simple:
--- a/scripts/dpkg-mergechangelogs.pl
+++ b/scripts/dpkg-mergechangelogs.pl
@@ -179,7 +179,9 @@ sub compare_versions {
        $a =~ s/~[^~]*$//;
        $b =~ s/~[^~]*$//;
     }
-    return version_compare($a, $b);
+    $a = Dpkg::Version->new($a);
+    $b = Dpkg::Version->new($b);
+    return $a <=> $b;
 }
 
 # Merge changelog entries smartly by merging individually the different

Of your patch, I only kept the non-regression test:

commit fc372437a25080989c6ab788fe0382ef508739a4
Author: Martin Packman <martin.packman@canonical.com>
Date:   Wed Dec 21 10:14:27 2011 +0100

    dpkg-mergechangelogs: supplementary non-regression test
    
    Add a test that ensures that dpkg-mergechangelogs deals correctly
    with invalid versions.
    
    Signed-off-by: Raphaël Hertzog <hertzog@debian.org>

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Pre-order a copy of the Debian Administrator's Handbook and help
liberate it: http://debian-handbook.info/liberation/




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#651993; Package dpkg-dev. (Wed, 21 Dec 2011 19:21:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Martin Packman <martin.packman@canonical.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 21 Dec 2011 19:21:05 GMT) Full text and rfc822 format available.

Message #29 received at 651993@bugs.debian.org (full text, mbox):

From: Martin Packman <martin.packman@canonical.com>
To: Raphael Hertzog <hertzog@debian.org>
Cc: 651993@bugs.debian.org
Subject: Re: Bug#651993: dpkg-mergechangelogs fails if any changelog contains an invalid version
Date: Wed, 21 Dec 2011 19:17:45 +0000
On 21/12/2011, Raphael Hertzog <hertzog@debian.org> wrote:
>
> Thanks for the report and the patch. I pushed a fix in git master.
> The fix itself is really simple:

Thanks Raphael! That cut down approach does work, though it also lacks
some of the benefits of the larger change. It's a judgement call
whether warning about invalid versions during merge is worthwhile, but
the rearrangement to only construct version objects once per entry in
the common case seems worth doing regardless to me.

Martin




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Developers <debian-dpkg@lists.debian.org>:
Bug#651993; Package dpkg-dev. (Wed, 21 Dec 2011 19:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Hertzog <hertzog@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Developers <debian-dpkg@lists.debian.org>. (Wed, 21 Dec 2011 19:33:03 GMT) Full text and rfc822 format available.

Message #34 received at 651993@bugs.debian.org (full text, mbox):

From: Raphael Hertzog <hertzog@debian.org>
To: Martin Packman <martin.packman@canonical.com>
Cc: 651993@bugs.debian.org
Subject: Re: Bug#651993: dpkg-mergechangelogs fails if any changelog contains an invalid version
Date: Wed, 21 Dec 2011 20:31:25 +0100
On Wed, 21 Dec 2011, Martin Packman wrote:
> Thanks Raphael! That cut down approach does work, though it also lacks
> some of the benefits of the larger change.

> It's a judgement call whether warning about invalid versions during
> merge is worthwhile

For this I have added a check in the Dpkg::Changelog parsing code:

commit 66a76d5abbc8dce24296108d109a96e7affad7cc
Author: Raphaël Hertzog <hertzog@debian.org>
Date:   Wed Dec 21 09:59:39 2011 +0100

    Dpkg::Changelog::Entry::Debian: check_header() now validates the version

> the rearrangement to only construct version objects once per entry in
> the common case seems worth doing regardless to me.

I found that the speed gain was not worth the amount of supplementary
code.

Cheers,
-- 
Raphaël Hertzog ◈ Debian Developer

Pre-order a copy of the Debian Administrator's Handbook and help
liberate it: http://debian-handbook.info/liberation/




Reply sent to Cyril Brulebois <kibi@debian.org>:
You have taken responsibility. (Tue, 31 Jan 2012 20:52:04 GMT) Full text and rfc822 format available.

Notification sent to Martin Packman <martin.packman@canonical.com>:
Bug acknowledged by developer. (Tue, 31 Jan 2012 20:52:05 GMT) Full text and rfc822 format available.

Message #39 received at 651993-close@bugs.debian.org (full text, mbox):

From: Cyril Brulebois <kibi@debian.org>
To: 651993-close@bugs.debian.org
Subject: Bug#651993: fixed in dpkg 1.16.2~multiarch
Date: Tue, 31 Jan 2012 20:48:56 +0000
Source: dpkg
Source-Version: 1.16.2~multiarch

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive:

dpkg-dev_1.16.2~multiarch_all.deb
  to main/d/dpkg/dpkg-dev_1.16.2~multiarch_all.deb
dpkg_1.16.2~multiarch.dsc
  to main/d/dpkg/dpkg_1.16.2~multiarch.dsc
dpkg_1.16.2~multiarch.tar.bz2
  to main/d/dpkg/dpkg_1.16.2~multiarch.tar.bz2
dpkg_1.16.2~multiarch_amd64.deb
  to main/d/dpkg/dpkg_1.16.2~multiarch_amd64.deb
dselect_1.16.2~multiarch_amd64.deb
  to main/d/dpkg/dselect_1.16.2~multiarch_amd64.deb
libdpkg-dev_1.16.2~multiarch_amd64.deb
  to main/d/dpkg/libdpkg-dev_1.16.2~multiarch_amd64.deb
libdpkg-perl_1.16.2~multiarch_all.deb
  to main/d/dpkg/libdpkg-perl_1.16.2~multiarch_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 651993@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Cyril Brulebois <kibi@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Tue, 31 Jan 2012 16:07:32 +0100
Source: dpkg
Binary: libdpkg-dev dpkg dpkg-dev libdpkg-perl dselect
Architecture: source amd64 all
Version: 1.16.2~multiarch
Distribution: experimental
Urgency: low
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Changed-By: Cyril Brulebois <kibi@debian.org>
Description: 
 dpkg       - Debian package management system
 dpkg-dev   - Debian package development tools
 dselect    - Debian package management front-end
 libdpkg-dev - Debian package management static library
 libdpkg-perl - Dpkg perl modules
Closes: 192619 367608 427945 595144 608884 627832 636238 642473 642608 642802 643746 643969 644370 646496 647915 648180 648217 649248 651481 651813 651993 652414 653575 654453 654626 655411 656496
Changes: 
 dpkg (1.16.2~multiarch) experimental; urgency=low
 .
   [ Cyril Brulebois ]
   * Non-maintainer upload. Let's push multiarch to the masses.
 .
   [ Guillem Jover ]
   * Move <config.h> and <compat.h> to the top of trigdeferred.l to properly
     use the configured features and compat code.
   * Honour --disable-nls when the system lacks obstack support, by updating
     the obstack compat module from gnulib.
   * Link the libdpkg unit tests with libcompat and libintl, so that systems
     needing them will compile correctly.
   * Check for the presence of the strnlen declaration and correctly provide
     the compat one in case the systems lacks it.
   * Do not assume existence of paths on the build system in the test suite.
   * Do not fail to link dselect on MacOS X when using --disable-nls.
   * Remove versioned coreutils Pre-Depends from dpkg due to the ancient
     md5sum transition. Reported by Bill Allombert <ballombe@debian.org>.
     Closes: #643746
   * Change dpkg-architecture to only compute the requested variables. This:
     - Fixes the bootstrapping problem, as the dpkg build system only needs
       the host architecture, for which dpkg itself is not required.
     - Reduces the amount of work performed, including loading and parsing
       unnecessary table files or calling either of gcc or dpkg programs.
   * Improve error message in dpkg-gencontrol and dpkg-gensymbols when
     debian/control does not have any package stanza. Closes: #642473
     Based on a patch by Kyle Willmon <kylewillmon@gmail.com>.
   * Add Pre-Depends on tar >= 1.23 (satisfied in stable) to dpkg due to it
     using the ‘--warning=no-timestamp’ option. Closes: #642802
   * Do not segfault on GNU/Linux when dpkg cannot retrieve the block size
     for the filesystem containing the info database. LP: #872734
   * Fix two memory leaks per tar entry in the tar extractor used on unpack.
   * Mark dpkg and dselect as Multi-Arch foreign.
     Reported by Steve Langasek <vorlon@debian.org>.
   * Mark dpkg-dev and libdpkg-perl as Multi-Arch foreign. Closes: #648217
     Thanks to Colin Watson <cjwatson@ubuntu.com>.
   * Add new deb-origin.5 man page. Closes: #608884
     Thanks to Matt Kraai <kraai@ftbfs.org>.
   * Return correct status on start-stop-daemon --status when using --pidfile.
   * Treat dpkg-deb compression level independently for each backend. This
     has the effect of changing the current behaviour for level 0 on all
     compressors except gzip.
   * Add new dpkg-deb -S option to specify the compression strategy. The only
     currently supported value is “extreme” for xz. Closes: #647915
   * Stop using brace expansion to install man pages by using dh_installman
     instead of dh_install, the former does not abort on empty glob expansion.
   * Do not use absolute paths for programs in perl and shell code.
   * Add missing ‘*’ in asprintf() and vasprintf() compat declarations.
   * Add support for virtual output binary:Summary and db:Status-Abbrev fields.
     Closes: #192619, #427945
   * Add support for virtual output source:Package and source:Version fields.
     Closes: #653575
   * Use a different temporary file per process on libcompat's vsnprintf()
     function to avoid race conditions from children after fork(3).
     Reported by Daniel Ruoso <daniel@ruoso.com>. Closes: #655411
   * Fix start-stop-daemon --exec and --name options on FreeBSD, NetBSD and
     OpenBSD by swapping the process matching implementations.
   * Fix start-stop-daemon --name option on GNU/Hurd to match the process name.
   * Document in more detail the implications of start-stop-daemon matching
     options. Closes: #367608
   * Improve and clarify dpkg-shlibdeps superfluous linking warning messages.
     Based on a patch by Peter Eisentraut <petere@debian.org>. Closes: #656496
 .
   [ Raphaël Hertzog ]
   * Update Dpkg::Shlibs to look into multiarch paths when cross-building
     too. Closes: #595144
   * Rewrite architecture.mk with explicit loops instead of duplicating many
     similar lines. Based on a patch by Thorsten Glaser <tg@mirbsd.de>.
   * Modify dpkg-gencontrol and dpkg-distaddfile to grab a write lock
     on debian/control before updating debian/files to avoid simultaneous
     updates. Closes: #642608
     Add libfile-fcntllock-perl to dpkg-dev's Depends since we use this module
     to handle the locking.
   * Update dpkg-gensymbols(1) to clarify that -e accepts shell patterns
     expansions and not regular expressions. And let dpkg-gensymbols output a
     warning when a pattern doesn't match any file. Closes: #649248
   * Add new option "-a <arch>" to dpkg-checkbuilddeps to check build
     dependencies for another architecture. This is really basic for now since
     it assumes all build dependencies must be satisfied on the listed
     architecture. Closes: #648180 Thanks to Colin Watson for the patch.
   * Error out if a dpkg database .list file is not a regular file. LP: #369898
   * Fix dpkg-mergechangelogs to not error out on invalid versions.
     Closes: #651993
   * Fix dpkg-source --commit on "3.0 (quilt)" when an explicit patch file
     is given with a relative filename. Closes: #652414
   * Further clarify in dpkg-source(1) the conditions under which it's possible
     to pass an explicit patch file to dpkg-source --commit.
   * Add new --query-features command to dpkg-buildflags. Thanks to Kees Cook
     for the patch. Closes: #651481
   * Fix description of Multi-Arch in deb-control(5). Closes: #654453
     Thanks to Jakub Wilk for spotting the mistake.
   * Drop misleading spaces in deb-symbols(5) in the format description.
   * Clean up dpkg-architecture(1) dropping useless information and
     adding a reference to /usr/share/dpkg/architecture.mk.
 .
   [ Jonathan Nieder ]
   * Bump po4a version in Build-Depends to 0.41, since earlier versions do
     not handle --srcdir correctly. Closes: #644370
 .
   [ Helge Kreutzmann ]
   * Fix a typo in man/dpkg-deb.1.
 .
   [ Updated dpkg translations ]
   * German (Sven Joachim).
   * Italian (Milo Casagrande). Closes: #627832
   * Swedish (Peter Krefting).
   * French (Christian Perrier)
 .
   [ Updated scripts translations ]
   * German (Helge Kreutzmann).
   * Spanish (Omar Campagne). Closes: #636238
   * Swedish (Peter Krefting).
 .
   [ Updated man page translations ]
   * German (Helge Kreutzmann), including typo fix in dpkg-genchanges
     Closes: #646496, sub optimal translation of package states LP: #368783
     and an fix by Chris Leick
   * Japanese (TAKAHASHI Motonobu).
   * Spanish (Omar Campagne). Closes: #643969
   * Swedish (Peter Krefting).
   * Minor errors corrected in French (thanks to David Prévot)
   * Fix translation of -B and -A options of dpkg-buildpackage.
     Thanks to Vincent Danjean. Closes: #654626
 .
   [ Updated dselect translations ]
   * Dutch (Jeroen Schot). Closes: #651813
Checksums-Sha1: 
 19d03327305ffe77a9a27cf2a97a1374a53d80c2 1402 dpkg_1.16.2~multiarch.dsc
 6791139ea5264dcf3b3f50145122c070217c77ee 5588042 dpkg_1.16.2~multiarch.tar.bz2
 5ace0fd530081b49d640062f831c24f953ae25a9 605912 libdpkg-dev_1.16.2~multiarch_amd64.deb
 fc6757f3914b99c84e46a4f10d568e10dff32363 2088674 dpkg_1.16.2~multiarch_amd64.deb
 c4092ecb5792ec2b95b378f35c699d16d46c104a 999194 dselect_1.16.2~multiarch_amd64.deb
 65f4ae079843f683a0fdc651c7d414d19fda6d3a 632066 dpkg-dev_1.16.2~multiarch_all.deb
 34e1227bfbff9e3f8d137775fa882e02f887ac9a 851502 libdpkg-perl_1.16.2~multiarch_all.deb
Checksums-Sha256: 
 91f596241ecebfac200bed00292ee9e2805fa00c97fa8991ebdf61775c6ac8ab 1402 dpkg_1.16.2~multiarch.dsc
 73ef3f3d188570ec0c954155fdc9da84c3623903d1d4ff21199285294d53747c 5588042 dpkg_1.16.2~multiarch.tar.bz2
 7166741d526899e12ca1a8a4dfc2ebaa48a639a7488a3a6c595d3ce8ccf488c2 605912 libdpkg-dev_1.16.2~multiarch_amd64.deb
 2f1722960e3d125d346af8f8ac257dd410924dab9b3cbbe99f31bd6f4ea4250a 2088674 dpkg_1.16.2~multiarch_amd64.deb
 9b036c4345d4410e5f0c32a43b35da397a43741a5270eb27244ef675fae04c10 999194 dselect_1.16.2~multiarch_amd64.deb
 1766ecaccc0c35fea78270157bc4e05424f7a38818f427fe4264273c9e656205 632066 dpkg-dev_1.16.2~multiarch_all.deb
 0094a37fb449957d457ab17f79a2d63ec28771c843109f4c10fcd118e159e55f 851502 libdpkg-perl_1.16.2~multiarch_all.deb
Files: 
 46f0ccf05408e6482a1df89d26c9d64e 1402 admin required dpkg_1.16.2~multiarch.dsc
 1fa36a11e3668cb7d0859a11c5f74f9b 5588042 admin required dpkg_1.16.2~multiarch.tar.bz2
 8a9998e958c240804c28cd6d15170aeb 605912 libdevel optional libdpkg-dev_1.16.2~multiarch_amd64.deb
 eb093790f536a3d6d7b20b0a95ed44f5 2088674 admin required dpkg_1.16.2~multiarch_amd64.deb
 daeaadba99f639c7f89c7a2b6ddf5d20 999194 admin optional dselect_1.16.2~multiarch_amd64.deb
 5017d8e3593dfbb23de750beddec15fa 632066 utils optional dpkg-dev_1.16.2~multiarch_all.deb
 dc7213111ff8469c6187179ac166a746 851502 perl optional libdpkg-perl_1.16.2~multiarch_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEARECAAYFAk8oSqMACgkQeGfVPHR5Nd1yTwCbBxbNYFb+mRuMOeyC3SRf7EdQ
zdkAmwVycK9u5n4lMiuuNkVfg9OgJiC9
=+ZZ4
-----END PGP SIGNATURE-----





Bug No longer marked as fixed in versions dpkg/1.16.2~multiarch and reopened. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 01 Feb 2012 00:42:18 GMT) Full text and rfc822 format available.

Bug Marked as found in versions dpkg/1.16.2~really1.16.1.2. Request was from Clint Adams <clint@debian.org> to control@bugs.debian.org. (Wed, 01 Feb 2012 02:09:16 GMT) Full text and rfc822 format available.

Reply sent to Guillem Jover <guillem@debian.org>:
You have taken responsibility. (Mon, 06 Feb 2012 00:07:22 GMT) Full text and rfc822 format available.

Notification sent to Martin Packman <martin.packman@canonical.com>:
Bug acknowledged by developer. (Mon, 06 Feb 2012 00:07:23 GMT) Full text and rfc822 format available.

Message #48 received at 651993-close@bugs.debian.org (full text, mbox):

From: Guillem Jover <guillem@debian.org>
To: 651993-close@bugs.debian.org
Subject: Bug#651993: fixed in dpkg 1.16.2~wipmultiarch
Date: Mon, 06 Feb 2012 00:02:22 +0000
Source: dpkg
Source-Version: 1.16.2~wipmultiarch

We believe that the bug you reported is fixed in the latest version of
dpkg, which is due to be installed in the Debian FTP archive:

dpkg-dev_1.16.2~wipmultiarch_all.deb
  to main/d/dpkg/dpkg-dev_1.16.2~wipmultiarch_all.deb
dpkg_1.16.2~wipmultiarch.dsc
  to main/d/dpkg/dpkg_1.16.2~wipmultiarch.dsc
dpkg_1.16.2~wipmultiarch.tar.bz2
  to main/d/dpkg/dpkg_1.16.2~wipmultiarch.tar.bz2
dpkg_1.16.2~wipmultiarch_amd64.deb
  to main/d/dpkg/dpkg_1.16.2~wipmultiarch_amd64.deb
dselect_1.16.2~wipmultiarch_amd64.deb
  to main/d/dpkg/dselect_1.16.2~wipmultiarch_amd64.deb
libdpkg-dev_1.16.2~wipmultiarch_amd64.deb
  to main/d/dpkg/libdpkg-dev_1.16.2~wipmultiarch_amd64.deb
libdpkg-perl_1.16.2~wipmultiarch_all.deb
  to main/d/dpkg/libdpkg-perl_1.16.2~wipmultiarch_all.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 651993@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Guillem Jover <guillem@debian.org> (supplier of updated dpkg package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Sun, 05 Feb 2012 23:39:40 +0100
Source: dpkg
Binary: libdpkg-dev dpkg dpkg-dev libdpkg-perl dselect
Architecture: source amd64 all
Version: 1.16.2~wipmultiarch
Distribution: experimental
Urgency: low
Maintainer: Dpkg Developers <debian-dpkg@lists.debian.org>
Changed-By: Guillem Jover <guillem@debian.org>
Description: 
 dpkg       - Debian package management system
 dpkg-dev   - Debian package development tools
 dselect    - Debian package management front-end
 libdpkg-dev - Debian package management static library
 libdpkg-perl - Dpkg perl modules
Closes: 192619 229357 367608 427945 595144 608884 627832 636238 642473 642608 642802 643746 643969 644370 646496 647915 648180 648217 649248 651481 651813 651993 652414 653575 654453 654626 655411 656496 657849
Changes: 
 dpkg (1.16.2~wipmultiarch) experimental; urgency=low
 .
   This is a WIP release, command line interfaces *will* change.
 .
   [ Guillem Jover ]
   * Move <config.h> and <compat.h> to the top of trigdeferred.l to properly
     use the configured features and compat code.
   * Honour --disable-nls when the system lacks obstack support, by updating
     the obstack compat module from gnulib.
   * Link the libdpkg unit tests with libcompat and libintl, so that systems
     needing them will compile correctly.
   * Check for the presence of the strnlen declaration and correctly provide
     the compat one in case the systems lacks it.
   * Do not assume existence of paths on the build system in the test suite.
   * Do not fail to link dselect on MacOS X when using --disable-nls.
   * Remove versioned coreutils Pre-Depends from dpkg due to the ancient
     md5sum transition. Reported by Bill Allombert <ballombe@debian.org>.
     Closes: #643746
   * Change dpkg-architecture to only compute the requested variables. This:
     - Fixes the bootstrapping problem, as the dpkg build system only needs
       the host architecture, for which dpkg itself is not required.
     - Reduces the amount of work performed, including loading and parsing
       unnecessary table files or calling either of gcc or dpkg programs.
   * Improve error message in dpkg-gencontrol and dpkg-gensymbols when
     debian/control does not have any package stanza. Closes: #642473
     Based on a patch by Kyle Willmon <kylewillmon@gmail.com>.
   * Add Pre-Depends on tar >= 1.23 (satisfied in stable) to dpkg due to it
     using the ‘--warning=no-timestamp’ option. Closes: #642802
   * Do not segfault on GNU/Linux when dpkg cannot retrieve the block size
     for the filesystem containing the info database. LP: #872734
   * Fix two memory leaks per tar entry in the tar extractor used on unpack.
   * Mark dpkg and dselect as Multi-Arch foreign.
     Reported by Steve Langasek <vorlon@debian.org>.
   * Mark dpkg-dev and libdpkg-perl as Multi-Arch foreign. Closes: #648217
     Thanks to Colin Watson <cjwatson@ubuntu.com>.
   * Add new deb-origin.5 man page. Closes: #608884
     Thanks to Matt Kraai <kraai@ftbfs.org>.
   * Return correct status on start-stop-daemon --status when using --pidfile.
   * Treat dpkg-deb compression level independently for each backend. This
     has the effect of changing the current behaviour for level 0 on all
     compressors except gzip.
   * Add new dpkg-deb -S option to specify the compression strategy. The only
     currently supported value is “extreme” for xz. Closes: #647915
   * Stop using brace expansion to install man pages by using dh_installman
     instead of dh_install, the former does not abort on empty glob expansion.
   * Do not use absolute paths for programs in perl and shell code.
   * Add missing ‘*’ in asprintf() and vasprintf() compat declarations.
   * Add support for virtual output binary:Summary and db:Status-Abbrev fields.
     Closes: #192619, #427945
   * Add support for virtual output source:Package and source:Version fields.
     Closes: #653575
   * Use a different temporary file per process on libcompat's vsnprintf()
     function to avoid race conditions from children after fork(3).
     Reported by Daniel Ruoso <daniel@ruoso.com>. Closes: #655411
   * Fix start-stop-daemon --exec and --name options on FreeBSD, NetBSD and
     OpenBSD by swapping the process matching implementations.
   * Fix start-stop-daemon --name option on GNU/Hurd to match the process name.
   * Document in more detail the implications of start-stop-daemon matching
     options. Closes: #367608
   * Improve and clarify dpkg-shlibdeps superfluous linking warning messages.
     Based on a patch by Peter Eisentraut <petere@debian.org>. Closes: #656496
 .
   [ Raphaël Hertzog ]
   * Update Dpkg::Shlibs to look into multiarch paths when cross-building
     too. Closes: #595144
   * Rewrite architecture.mk with explicit loops instead of duplicating many
     similar lines. Based on a patch by Thorsten Glaser <tg@mirbsd.de>.
   * Modify dpkg-gencontrol and dpkg-distaddfile to grab a write lock
     on debian/control before updating debian/files to avoid simultaneous
     updates. Closes: #642608
     Add libfile-fcntllock-perl to dpkg-dev's Depends since we use this module
     to handle the locking.
   * Update dpkg-gensymbols(1) to clarify that -e accepts shell patterns
     expansions and not regular expressions. And let dpkg-gensymbols output a
     warning when a pattern doesn't match any file. Closes: #649248
   * Add new option "-a <arch>" to dpkg-checkbuilddeps to check build
     dependencies for another architecture. This is really basic for now since
     it assumes all build dependencies must be satisfied on the listed
     architecture. Closes: #648180 Thanks to Colin Watson for the patch.
   * Error out if a dpkg database .list file is not a regular file. LP: #369898
   * Fix dpkg-mergechangelogs to not error out on invalid versions.
     Closes: #651993
   * Fix dpkg-source --commit on "3.0 (quilt)" when an explicit patch file
     is given with a relative filename. Closes: #652414
   * Further clarify in dpkg-source(1) the conditions under which it's possible
     to pass an explicit patch file to dpkg-source --commit.
   * Add new --query-features command to dpkg-buildflags. Thanks to Kees Cook
     for the patch. Closes: #651481
   * Fix description of Multi-Arch in deb-control(5). Closes: #654453
     Thanks to Jakub Wilk for spotting the mistake.
   * Drop misleading spaces in deb-symbols(5) in the format description.
   * Clean up dpkg-architecture(1) dropping useless information and
     adding a reference to /usr/share/dpkg/architecture.mk.
   * Update dpkg-buildpackage to use the "build-arch" (for -B) and
     "build-indep" (for -A) targets unless "make -qn" says that they do not
     exist. Closes: #229357
 .
   [ Jonathan Nieder ]
   * Bump po4a version in Build-Depends to 0.41, since earlier versions do
     not handle --srcdir correctly. Closes: #644370
 .
   [ Helge Kreutzmann ]
   * Fix a typo in man/dpkg-deb.1.
 .
   [ Updated dpkg translations ]
   * German (Sven Joachim).
   * Italian (Milo Casagrande). Closes: #627832, #657849
   * Swedish (Peter Krefting).
   * French (Christian Perrier)
 .
   [ Updated scripts translations ]
   * German (Helge Kreutzmann).
   * Spanish (Omar Campagne). Closes: #636238
   * Swedish (Peter Krefting).
 .
   [ Updated man page translations ]
   * German (Helge Kreutzmann), including typo fix in dpkg-genchanges
     Closes: #646496, sub optimal translation of package states LP: #368783
     and an fix by Chris Leick
   * Japanese (TAKAHASHI Motonobu).
   * Spanish (Omar Campagne). Closes: #643969
   * Swedish (Peter Krefting).
   * Minor errors corrected in French (thanks to David Prévot)
   * Fix translation of -B and -A options of dpkg-buildpackage.
     Thanks to Vincent Danjean. Closes: #654626
 .
   [ Updated dselect translations ]
   * Dutch (Jeroen Schot). Closes: #651813
Checksums-Sha1: 
 5b350a13d4749a68f55688f53bd934ca33b7bc34 1414 dpkg_1.16.2~wipmultiarch.dsc
 e3c394da92562bc2bf9bb18a6832c575b32cc2a0 5569622 dpkg_1.16.2~wipmultiarch.tar.bz2
 7ce788ea96a3df3cda27c34e5769a48ccfd4cfe1 609206 libdpkg-dev_1.16.2~wipmultiarch_amd64.deb
 840f46fce0fcf7c1214924582a1100dd8d358bc4 2086476 dpkg_1.16.2~wipmultiarch_amd64.deb
 ee2acabe565079c9f1b559443bdc780079040aeb 1000514 dselect_1.16.2~wipmultiarch_amd64.deb
 a6d02b21cd5eac118de310187eae7a6bb63943c5 635810 dpkg-dev_1.16.2~wipmultiarch_all.deb
 728863e43f9185e3182eb78d807b670441e9dd94 851128 libdpkg-perl_1.16.2~wipmultiarch_all.deb
Checksums-Sha256: 
 ce7050ed905c72f823fdb183714f5b5c546e5015ec79dbdf759281c7c60faaae 1414 dpkg_1.16.2~wipmultiarch.dsc
 24b73f91f9e93ddd984172b35a52e6818c2195002ff4d5e72898712d802a3efa 5569622 dpkg_1.16.2~wipmultiarch.tar.bz2
 8a31ad426d8b7e363cce14516d73be1575b724a2683c80322c14f379b60e7efb 609206 libdpkg-dev_1.16.2~wipmultiarch_amd64.deb
 e3f3cef7dd88a5632b4139a042b8943397e512699504ca9abdf3ee97604a9208 2086476 dpkg_1.16.2~wipmultiarch_amd64.deb
 2addf6880dc5d2ee2a817519987fdc9a59751d511de4aa689b19095c0392c4b4 1000514 dselect_1.16.2~wipmultiarch_amd64.deb
 f4a65c7ebd66f7e5eba877d7a9af98ebb33ea9755fd72730d7f9416e6d0b8b7d 635810 dpkg-dev_1.16.2~wipmultiarch_all.deb
 d972b0812219c2afaca254306e8bf5e3feca49c4324924a5c5bb640447cca72d 851128 libdpkg-perl_1.16.2~wipmultiarch_all.deb
Files: 
 7c1aa845fad678163118b63c2053aee3 1414 admin required dpkg_1.16.2~wipmultiarch.dsc
 2c02844dc317beaf6d5f4e22e966813c 5569622 admin required dpkg_1.16.2~wipmultiarch.tar.bz2
 f49a6d3e6ea649b8bb36afd41258bd3c 609206 libdevel optional libdpkg-dev_1.16.2~wipmultiarch_amd64.deb
 6b3fba7d1254c0e0dda083c94e01a749 2086476 admin required dpkg_1.16.2~wipmultiarch_amd64.deb
 fec42261e17f7b60a8cb2339d8b4fa1a 1000514 admin optional dselect_1.16.2~wipmultiarch_amd64.deb
 64b69c596994b4716ed8a0f7ef6c2d0e 635810 utils optional dpkg-dev_1.16.2~wipmultiarch_all.deb
 c8e38c68397fda8dc171bc2a6d7e0c4f 851128 perl optional libdpkg-perl_1.16.2~wipmultiarch_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.11 (GNU/Linux)

iEYEARECAAYFAk8vCk4ACgkQuW9ciZ2SjJuPQwCgk4tpFGkzvc7sKsBqQfzw7Dob
NDkAn3uyGGvGcL1KfN49EztspiEGaB47
=Tkrm
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 05 Mar 2012 07:40:53 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 08:34:59 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.